<template>
  <div>
    <header-slot>
      <div class="container">
        <div class="left">
          <div class="check">
            <select v-model="filter">
              <option value="1" selected>Тип</option>
              <option value="2">Бренд</option>
              <option value="3">Модель</option>
              <option value="4">Ціна</option>
              <option value="5">Колір</option>
            </select> <br />
            <input v-model="search" type="text" placeholder="Пошук" /> <br /> <br />
            <button @click="$router.push('/add')">Додати телефон до каталогу</button>
          </div>
        </div>

        <div class="right">
          <div class="loading" v-if="isLoading">Loading......</div>
          <div class="laptop" v-else>
            <product-card v-for="prod in filteredItems" :key="prod.id" :product-obj="prod" />
          </div>
        </div>
      </div>
    </header-slot>
  </div>
</template>

<script>
import HeaderSlot from "@/components/HeaderSlot.vue";
import { mapGetters, mapActions } from "vuex";
import ProductCard from "@/components/ProductCard.vue";

export default {
  name: 'CatalogPage',

  data() {
    return {
      laptop: {},
      filter: '',
      search: '',
    }
  },

  components: {
    HeaderSlot, ProductCard,
  },

  computed: {
    ...mapGetters('laptops', ['getItemsList', 'isLoading']),

    filteredItems() {
      if (this.filter == "1") {
        return this.getItemsList.filter((prod) => {
          return prod.type.toLowerCase().includes(this.search.toLowerCase());
        });
      }
      else if (this.filter == "2") {
        return this.getItemsList.filter((prod) => {
          return prod.brand.toLowerCase().includes(this.search.toLowerCase());
        });
      }
      else if (this.filter == "3") {
        return this.getItemsList.filter((prod) => {
          return prod.model.toLowerCase().includes(this.search.toLowerCase());
        });
      }
      else if (this.filter == "4") {
        return this.getItemsList.filter((prod) => {
          return String(prod.price).includes(this.search);
        });
      }
      else if (this.filter == "5") {
        return this.getItemsList.filter((prod) => {
          return prod.color.toLowerCase().includes(this.search.toLowerCase());
        })
      }
      else {
        return this.getItemsList;
      }
    },
  },

  created() {
    this.loadList()
  },

  methods: {
    ...mapActions('laptops', ['loadList']),
  },
}
</script>

<style lang="css" scoped>
.container{
  display: flex;
  margin-left: 30px;
}

.check {
  display: flex;
  flex-direction: column;
  border: 1px solid #ccc;
  padding: 10px;
  border-radius: 7px;
  margin-right: 30px;
  margin-top: 15px;
}

.check div {
  display: flex;
  align-items: center;
}

.check input,
.check select{
  margin: 5px;
  border-radius: 3px;
}

.check button{
  padding: 10px 20px;
  border: none;
  border-radius: 4px;
  cursor: pointer;
  transition: background-color 0.2s;
}

.check button:hover {
  background-color: crimson;
  color: #fff;
}

.right{
  margin-left: 30px;
}

.loading{
  margin-top: 50px;
}

.laptop{
  display: flex;
  flex-direction: row;
  flex-wrap: wrap;
  margin-top: 15px;
}
</style>